# frozen_string_literal: true

module Apiphobic
module Serializers
module JsonApi
  module ClassMethods
    def type_block
      proc {
        @object
          .class
          .name
          .gsub(/\A[^:]+::/, '')
          .split('::')
          .reverse
          .join('::')
          .tableize
          .dasherize
          .tr('/', '-')
          .pluralize
      }
    end

    def attribute(name, _options = {}, &block)
      block                                         ||= proc { @object.public_send(name) }
      attribute_blocks[name.to_s.tr('_', '-').to_sym] = block
    end
  end

  def self.included(base)
    base.extend(ClassMethods)
  end
end
end
end
